<?php

namespace App\Http\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class ReminderRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('reminders'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=
            [
                'cart_leave'=> 'required|numeric',
                'cart_total'=> 'required|numeric',
                'discount_type'=> 'required|in:value,percentage',
                'discount_amount'=> 'required|numeric',
                'timing'=> 'required|numeric',
                'send_notification'=> 'required|in:email,sms,both',
            ];

        if(request('discount_type') == 'percentage')
        {
            $rules['discount_amount'] = 'required|numeric|max:100';
        }
        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required|max:100',
                'description_'.$lang->local=> 'required',
            ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes=
            [
                'cart_leave' => __('reminders.cart_leave'),
                'cart_total' => __('reminders.cart_total'),
                'discount_type' => __('reminders.discount_type'),
                'discount_amount' => __('reminders.discount_amount'),
                'timing' => __('reminders.timing'),
                'send_notification' => __('reminders.send_notification'),
            ];

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => $service->{'name_'.$lang->local} ?? __('reminders.name').' '.$lang->local,
                'description_'.$lang->local => $service->{'description_'.$lang->local} ?? __('reminders.description').' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
